Flutter 技术入门与实战 (29):开启 Flutter 之旅 3.6

阅读数:2 2019 年 12 月 15 日 18:48

Flutter技术入门与实战(29):开启Flutter之旅 3.6

(异常处理)

内容简介
第 1 章介绍 Flutter 的基本概念,并搭建第 yi 个 Flutter 程序,来感受一下 Flutter 之美。
第 2 章介绍几个重要知识点,如入口程序、Material Design、Flutter 主题、无状态组件和有状态组件、使用包资源、Http 请求。
第 3 章简单介绍 Dart 语言。Dart 语言是 Flutter SDK 指定的语言,我们很有必要补充一下它的基础知识,包括语法特性、基本语句、面向对象等。
第 4 章介绍常用组件。Flutter 里有一个非常重要的核心理念:一切皆为组件,本章主要讲解开发中用得 * 频繁的组件,如容器组件、图片组件、文本组件、图标组件和表单组件等。
第 5 章介绍 Material Design 风格的组件,Material Design 风格是一种非常有质感的设计风格,并提供一些默认的交互动画。本章将分类介绍这些组件。
第 6 章介绍 Cupertino 风格的组件,这是一类 iOS 风格的组件,如 CupertinoTabBar、CupertinoPageScaffold、CupertinoTabScaffold、CupertinoTabView 等。
第 7 章介绍页面布局的基础知识和技巧,如基础布局处理、宽高尺寸处理、列表及表格布局等,* 后通过一个综合布局示例来演示如何编写复杂的页面。
第 8 章介绍如何处理手势,如轻击、拖动和缩放等。Flutter 中提供 GestureDetector 进行手势检测,并为手势检测提供了相应的监听。
第 9 章介绍如何加载、处理、展示资源和图片,如添加资源和图片、自定义字体等。
第 10 章介绍路由及导航是如何处理的,包括页面的渲染以及数据传递。
第 11 章介绍组件装饰和视觉效果的处理,如 Opacity(透明度处理)、DecoratedBox(装饰盒子)、RotatedBox(旋转盒子)、Clip(剪裁处理)和 CustomPainter(自定义画板)。
第 12 章介绍动画效果的制作,包含两个动画组件的使用:用 AnimatedOpacity 实现渐变效果、用 Hero 实现页面切换动画。
第 13 章介绍 Flutter 插件开发的入门知识。Flutter 插件可以和原生程序打交道,比如调用蓝牙、启用 WIFI、打开手电筒,等等。
第 14 章介绍开发工具及使用技巧,介绍几款常用的 IDE 工具,从代码的编写、辅助功能、程序调试、性能分析等多方面讲解工具及使用技巧。
第 15 章介绍测试与发布应用,包括:测试应用、发布 Android 版和 iOS 版 App。
第 16 章通过一个综合案例介绍如何使用 Flutter 实现即时通讯 App 的界面。

异常是表示发生了意外的错误,如果没有捕获异常,引发异常的隔离程序将被挂起,并且程序将被终止。

Dart 代码可以抛出并捕获异常,但与 Java 相反,Dart 的所有异常都是未检查的异常。方法不声明它们可能抛出哪些异常,也不需要捕获任何异常。

Dart 提供了异常和错误类型以及许多预定义的子类型。当然,也可以定义自己的异常。然而,Dart 程序可以抛出任何非空对象。

1. 抛出异常

下面是一个抛出或引发异常的例子:

复制代码
throw FormatException('抛出一个 FormatException 异常');

你也可以抛出任意对象:

复制代码
throw '数据非法!';

提示 稳定健壮的程序一定是做了大量异常处理的,所以建议你在编写程序时尽量考虑到可能发生异常的情况。

2. 捕获异常

你可以指定一个或两个参数来捕获异常(catch),第一个是抛出的异常,第二个是堆栈跟踪(StackTrace 对象)。如下面代码所示:

复制代码
try {
// ···
} on Exception catch (e) {
print('Exception details:\n $e');
} catch (e, s) {
print('Exception details:\n $e');
print('Stack trace:\n $s');
}

上面的代码第一个 catch 用来捕获异常详细信息,第二个 catch 是堆栈跟踪信息。

3. Finally

要确保某些代码能够运行,无论是否抛出异常,请使用 finally 子句。如果没有 catch 子句匹配异常,则异常在 finally 子句运行后传播。如下面代码所示,在最下加上了 finally 语句:

复制代码
try {
// ...
} on Exception catch (e) {
print('Exception details:\n $e');
} catch (e, s) {
print('Exception details:\n $e');
print('Stack trace:\n $s');
} finally {
print('Do some thing:\n');
}

Flutter技术入门与实战(29):开启Flutter之旅 3.6

购书地址 https://item.jd.com/12526484.html?dist=jd

评论

发布